/*
 * The Clear BSD License
 * Copyright 2017-2018 NXP
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without modification,
 * are permitted (subject to the limitations in the disclaimer below) provided
 *  that the following conditions are met:
 *
 * o Redistributions of source code must retain the above copyright notice, this list
 *   of conditions and the following disclaimer.
 *
 * o Redistributions in binary form must reproduce the above copyright notice, this
 *   list of conditions and the following disclaimer in the documentation and/or
 *   other materials provided with the distribution.
 *
 * o Neither the name of the copyright holder nor the names of its
 *   contributors may be used to endorse or promote products derived from this
 *   software without specific prior written permission.
 *
 * NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE.
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 * ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
/***********************************************************************************************************************
 * This file was generated by the MCUXpresso Config Tools. Any manual edits made to this file
 * will be overwritten if the respective MCUXpresso Config Tools is used to update this file.
 **********************************************************************************************************************/

/* clang-format off */
/* TEXT BELOW IS USED AS SETTING FOR TOOLS *************************************
!!GlobalInfo
product: Peripherals v4.1
processor: LPC54618J512
package_id: LPC54618J512ET180
mcu_data: ksdk2_0
processor_version: 0.0.12
board: LPCXpresso54618
functionalGroups:
- name: BOARD_InitPeripherals
  selectedCore: core0
- name: BOARD_InitBUTTONsPeripheral
  id_prefix: BOARD_
  selectedCore: core0
- name: BOARD_InitLEDsPeripheral
  id_prefix: BOARD_
  selectedCore: core0
- name: BOARD_InitPMod_BRIDGEPeripheral
  id_prefix: BOARD_
  selectedCore: core0
- name: BOARD_InitACCELPeripheral
  id_prefix: BOARD_
  selectedCore: core0
- name: BOARD_InitQSPI_FLASHPeripheral
  id_prefix: BOARD_
  selectedCore: core0
- name: BOARD_InitDEBUG_UARTPeripheral
  id_prefix: BOARD_
  selectedCore: core0
- name: BOARD_InitENETPeripheral
  id_prefix: BOARD_
  selectedCore: core0
- name: BOARD_InitI2SPeripheral
  id_prefix: BOARD_
  selectedCore: core0
 * BE CAREFUL MODIFYING THIS COMMENT - IT IS YAML SETTINGS FOR TOOLS **********/

/* TEXT BELOW IS USED AS SETTING FOR TOOLS *************************************
component:
- type: 'system'
- type_id: 'system'
- global_system_definitions: []
 * BE CAREFUL MODIFYING THIS COMMENT - IT IS YAML SETTINGS FOR TOOLS **********/
/* clang-format on */

/***********************************************************************************************************************
 * Included files
 **********************************************************************************************************************/
#include "peripherals.h"

/***********************************************************************************************************************
 * BOARD_InitBUTTONsPeripheral functional group
 **********************************************************************************************************************/
/***********************************************************************************************************************
 * SW initialization code
 **********************************************************************************************************************/
/* clang-format off */
/* TEXT BELOW IS USED AS SETTING FOR TOOLS *************************************
instance:
- name: 'SW'
- type: 'lpc_gpio'
- mode: 'GPIO'
- type_id: 'lpc_gpio_cafc42e5f2c30132836e2ae7603e8a1e'
- functional_group: 'BOARD_InitBUTTONsPeripheral'
- peripheral: 'GPIO'
- config_sets:
  - lpc_gpio:
    - gpioConfig: []
 * BE CAREFUL MODIFYING THIS COMMENT - IT IS YAML SETTINGS FOR TOOLS **********/
/* clang-format on */

void BOARD_SW_init(void) {
}

/***********************************************************************************************************************
 * BOARD_InitLEDsPeripheral functional group
 **********************************************************************************************************************/
/***********************************************************************************************************************
 * LEDS initialization code
 **********************************************************************************************************************/
/* clang-format off */
/* TEXT BELOW IS USED AS SETTING FOR TOOLS *************************************
instance:
- name: 'LEDS'
- type: 'lpc_gpio'
- mode: 'GPIO'
- type_id: 'lpc_gpio_cafc42e5f2c30132836e2ae7603e8a1e'
- functional_group: 'BOARD_InitLEDsPeripheral'
- peripheral: 'GPIO'
- config_sets:
  - lpc_gpio:
    - gpioConfig: []
 * BE CAREFUL MODIFYING THIS COMMENT - IT IS YAML SETTINGS FOR TOOLS **********/
/* clang-format on */

void BOARD_LEDS_init(void) {
}

/***********************************************************************************************************************
 * BOARD_InitPMod_BRIDGEPeripheral functional group
 **********************************************************************************************************************/
/***********************************************************************************************************************
 * BRIDGE_GPIO initialization code
 **********************************************************************************************************************/
/* clang-format off */
/* TEXT BELOW IS USED AS SETTING FOR TOOLS *************************************
instance:
- name: 'BRIDGE_GPIO'
- type: 'lpc_gpio'
- mode: 'GPIO'
- type_id: 'lpc_gpio_cafc42e5f2c30132836e2ae7603e8a1e'
- functional_group: 'BOARD_InitPMod_BRIDGEPeripheral'
- peripheral: 'GPIO'
- config_sets:
  - lpc_gpio:
    - gpioConfig: []
 * BE CAREFUL MODIFYING THIS COMMENT - IT IS YAML SETTINGS FOR TOOLS **********/
/* clang-format on */

void BOARD_BRIDGE_GPIO_init(void) {
}

/***********************************************************************************************************************
 * PMOD_SPI initialization code
 **********************************************************************************************************************/
/* clang-format off */
/* TEXT BELOW IS USED AS SETTING FOR TOOLS *************************************
instance:
- name: 'PMOD_SPI'
- type: 'flexcomm_spi'
- mode: 'SPI_Polling'
- type_id: 'flexcomm_spi_fa73bcfbc0a2fd3b8c6ba5b0b1f1446f'
- functional_group: 'BOARD_InitPMod_BRIDGEPeripheral'
- peripheral: 'FLEXCOMM3'
- config_sets:
  - fsl_spi:
    - spi_mode: 'kSPI_Master'
    - clockSource: 'FXCOMFunctionClock'
    - clockSourceFreq: 'GetFreq'
    - spi_master_config:
      - enableLoopback: 'false'
      - enableMaster: 'true'
      - polarity: 'kSPI_ClockPolarityActiveHigh'
      - phase: 'kSPI_ClockPhaseFirstEdge'
      - direction: 'kSPI_MsbFirst'
      - baudRate_Bps: '500000'
      - dataWidth: 'kSPI_Data8Bits'
      - sselNum: 'kSPI_Ssel0'
      - sselPol: 'kSPI_SpolActiveAllLow'
      - txWatermark: 'kSPI_TxFifo0'
      - rxWatermark: 'kSPI_RxFifo1'
      - delayConfig:
        - preDelay: '0'
        - postDelay: '0'
        - frameDelay: '0'
        - transferDelay: '0'
    - quick_selection: 'QS_SPI_1'
 * BE CAREFUL MODIFYING THIS COMMENT - IT IS YAML SETTINGS FOR TOOLS **********/
/* clang-format on */
const spi_master_config_t BOARD_PMOD_SPI_config = {
  .enableLoopback = false,
  .enableMaster = true,
  .polarity = kSPI_ClockPolarityActiveHigh,
  .phase = kSPI_ClockPhaseFirstEdge,
  .direction = kSPI_MsbFirst,
  .baudRate_Bps = 500000,
  .dataWidth = kSPI_Data8Bits,
  .sselNum = kSPI_Ssel0,
  .sselPol = kSPI_SpolActiveAllLow,
  .txWatermark = kSPI_TxFifo0,
  .rxWatermark = kSPI_RxFifo1,
  .delayConfig = {
    .preDelay = 0,
    .postDelay = 0,
    .frameDelay = 0,
    .transferDelay = 0
  }
};

void BOARD_PMOD_SPI_init(void) {
  RESET_PeripheralReset( kFC3_RST_SHIFT_RSTn);
  /* Initialization function */
  SPI_MasterInit(BOARD_PMOD_SPI_PERIPHERAL, &BOARD_PMOD_SPI_config, BOARD_PMOD_SPI_CLOCK_SOURCE);
}

/***********************************************************************************************************************
 * PMOD_I2C initialization code
 **********************************************************************************************************************/
/* clang-format off */
/* TEXT BELOW IS USED AS SETTING FOR TOOLS *************************************
instance:
- name: 'PMOD_I2C'
- type: 'flexcomm_i2c'
- mode: 'I2C_Polling'
- type_id: 'flexcomm_i2c_567d1a9d97c12e5d39b00259c3436dc4'
- functional_group: 'BOARD_InitPMod_BRIDGEPeripheral'
- peripheral: 'FLEXCOMM1'
- config_sets:
  - fsl_i2c:
    - i2c_mode: 'kI2C_Master'
    - clockSource: 'FXCOMFunctionClock'
    - clockSourceFreq: 'GetFreq'
    - i2c_master_config:
      - enableMaster: 'true'
      - baudRate_Bps: '100000'
      - enableTimeout: 'false'
    - quick_selection: 'QS_I2C_Master'
 * BE CAREFUL MODIFYING THIS COMMENT - IT IS YAML SETTINGS FOR TOOLS **********/
/* clang-format on */
const i2c_master_config_t BOARD_PMOD_I2C_config = {
  .enableMaster = true,
  .baudRate_Bps = 100000,
  .enableTimeout = false
};

void BOARD_PMOD_I2C_init(void) {
  RESET_PeripheralReset( kFC1_RST_SHIFT_RSTn);
  /* Initialization function */
  I2C_MasterInit(BOARD_PMOD_I2C_PERIPHERAL, &BOARD_PMOD_I2C_config, BOARD_PMOD_I2C_CLOCK_SOURCE);
}

/***********************************************************************************************************************
 * BOARD_InitACCELPeripheral functional group
 **********************************************************************************************************************/
/***********************************************************************************************************************
 * ACCEL initialization code
 **********************************************************************************************************************/
/* clang-format off */
/* TEXT BELOW IS USED AS SETTING FOR TOOLS *************************************
instance:
- name: 'ACCEL'
- type: 'flexcomm_i2c'
- mode: 'I2C_Polling'
- type_id: 'flexcomm_i2c_567d1a9d97c12e5d39b00259c3436dc4'
- functional_group: 'BOARD_InitACCELPeripheral'
- peripheral: 'FLEXCOMM2'
- config_sets:
  - fsl_i2c:
    - i2c_mode: 'kI2C_Master'
    - clockSource: 'FXCOMFunctionClock'
    - clockSourceFreq: 'GetFreq'
    - i2c_master_config:
      - enableMaster: 'true'
      - baudRate_Bps: '100000'
      - enableTimeout: 'false'
    - quick_selection: 'QS_I2C_Master'
 * BE CAREFUL MODIFYING THIS COMMENT - IT IS YAML SETTINGS FOR TOOLS **********/
/* clang-format on */
const i2c_master_config_t BOARD_ACCEL_config = {
  .enableMaster = true,
  .baudRate_Bps = 100000,
  .enableTimeout = false
};

void BOARD_ACCEL_init(void) {
  RESET_PeripheralReset( kFC2_RST_SHIFT_RSTn);
  /* Initialization function */
  I2C_MasterInit(BOARD_ACCEL_PERIPHERAL, &BOARD_ACCEL_config, BOARD_ACCEL_CLOCK_SOURCE);
}

/***********************************************************************************************************************
 * ACCL_INTR initialization code
 **********************************************************************************************************************/
/* clang-format off */
/* TEXT BELOW IS USED AS SETTING FOR TOOLS *************************************
instance:
- name: 'ACCL_INTR'
- type: 'lpc_gpio'
- mode: 'GPIO'
- type_id: 'lpc_gpio_cafc42e5f2c30132836e2ae7603e8a1e'
- functional_group: 'BOARD_InitACCELPeripheral'
- peripheral: 'GPIO'
- config_sets:
  - lpc_gpio:
    - gpioConfig: []
 * BE CAREFUL MODIFYING THIS COMMENT - IT IS YAML SETTINGS FOR TOOLS **********/
/* clang-format on */

void BOARD_ACCL_INTR_init(void) {
}

/***********************************************************************************************************************
 * BOARD_InitQSPI_FLASHPeripheral functional group
 **********************************************************************************************************************/
/***********************************************************************************************************************
 * SPIFI_RSTn initialization code
 **********************************************************************************************************************/
/* clang-format off */
/* TEXT BELOW IS USED AS SETTING FOR TOOLS *************************************
instance:
- name: 'SPIFI_RSTn'
- type: 'lpc_gpio'
- mode: 'GPIO'
- type_id: 'lpc_gpio_cafc42e5f2c30132836e2ae7603e8a1e'
- functional_group: 'BOARD_InitQSPI_FLASHPeripheral'
- peripheral: 'GPIO'
- config_sets:
  - lpc_gpio:
    - gpioConfig: []
 * BE CAREFUL MODIFYING THIS COMMENT - IT IS YAML SETTINGS FOR TOOLS **********/
/* clang-format on */

void BOARD_SPIFI_RSTn_init(void) {
}

/***********************************************************************************************************************
 * BOARD_InitDEBUG_UARTPeripheral functional group
 **********************************************************************************************************************/
/***********************************************************************************************************************
 * DEBUG_UART initialization code
 **********************************************************************************************************************/
/* clang-format off */
/* TEXT BELOW IS USED AS SETTING FOR TOOLS *************************************
instance:
- name: 'DEBUG_UART'
- type: 'flexcomm_usart'
- mode: 'polling'
- type_id: 'flexcomm_usart_fcc110cc6b16332e9dfd9e0df675e21f'
- functional_group: 'BOARD_InitDEBUG_UARTPeripheral'
- peripheral: 'FLEXCOMM0'
- config_sets:
  - usartConfig_t:
    - usartConfig:
      - clockSource: 'FXCOMFunctionClock'
      - clockSourceFreq: 'GetFreq'
      - baudRate_Bps: '115200'
      - parityMode: 'kUSART_ParityDisabled'
      - stopBitCount: 'kUSART_OneStopBit'
      - bitCountPerChar: 'kUSART_7BitsPerChar'
      - loopback: 'false'
      - txWatermark: 'kUSART_TxFifo0'
      - rxWatermark: 'kUSART_RxFifo1'
      - enableRx: 'false'
      - enableTx: 'false'
 * BE CAREFUL MODIFYING THIS COMMENT - IT IS YAML SETTINGS FOR TOOLS **********/
/* clang-format on */
const usart_config_t BOARD_DEBUG_UART_config = {
  .baudRate_Bps = 115200,
  .parityMode = kUSART_ParityDisabled,
  .stopBitCount = kUSART_OneStopBit,
  .bitCountPerChar = kUSART_7BitsPerChar,
  .loopback = false,
  .txWatermark = kUSART_TxFifo0,
  .rxWatermark = kUSART_RxFifo1,
  .enableRx = false,
  .enableTx = false
};

void BOARD_DEBUG_UART_init(void) {
  /* Reset FLEXCOMM device */
  RESET_PeripheralReset(kFC0_RST_SHIFT_RSTn);
  USART_Init(BOARD_DEBUG_UART_PERIPHERAL, &BOARD_DEBUG_UART_config, BOARD_DEBUG_UART_CLOCK_SOURCE);
}

/***********************************************************************************************************************
 * BOARD_InitENETPeripheral functional group
 **********************************************************************************************************************/
/***********************************************************************************************************************
 * ENET_PHY_RSTn initialization code
 **********************************************************************************************************************/
/* clang-format off */
/* TEXT BELOW IS USED AS SETTING FOR TOOLS *************************************
instance:
- name: 'ENET_PHY_RSTn'
- type: 'lpc_gpio'
- mode: 'GPIO'
- type_id: 'lpc_gpio_cafc42e5f2c30132836e2ae7603e8a1e'
- functional_group: 'BOARD_InitENETPeripheral'
- peripheral: 'GPIO'
- config_sets:
  - lpc_gpio:
    - gpioConfig: []
 * BE CAREFUL MODIFYING THIS COMMENT - IT IS YAML SETTINGS FOR TOOLS **********/
/* clang-format on */

void BOARD_ENET_PHY_RSTn_init(void) {
}

/***********************************************************************************************************************
 * BOARD_InitI2SPeripheral functional group
 **********************************************************************************************************************/
/***********************************************************************************************************************
 * I2S_I2C initialization code
 **********************************************************************************************************************/
/* clang-format off */
/* TEXT BELOW IS USED AS SETTING FOR TOOLS *************************************
instance:
- name: 'I2S_I2C'
- type: 'flexcomm_i2c'
- mode: 'I2C_Polling'
- type_id: 'flexcomm_i2c_567d1a9d97c12e5d39b00259c3436dc4'
- functional_group: 'BOARD_InitI2SPeripheral'
- peripheral: 'FLEXCOMM2'
- config_sets:
  - fsl_i2c:
    - i2c_mode: 'kI2C_Master'
    - clockSource: 'FXCOMFunctionClock'
    - clockSourceFreq: 'GetFreq'
    - i2c_master_config:
      - enableMaster: 'true'
      - baudRate_Bps: '100000'
      - enableTimeout: 'false'
    - quick_selection: 'QS_I2C_Master'
 * BE CAREFUL MODIFYING THIS COMMENT - IT IS YAML SETTINGS FOR TOOLS **********/
/* clang-format on */
const i2c_master_config_t BOARD_I2S_I2C_config = {
  .enableMaster = true,
  .baudRate_Bps = 100000,
  .enableTimeout = false
};

void BOARD_I2S_I2C_init(void) {
  RESET_PeripheralReset( kFC2_RST_SHIFT_RSTn);
  /* Initialization function */
  I2C_MasterInit(BOARD_I2S_I2C_PERIPHERAL, &BOARD_I2S_I2C_config, BOARD_I2S_I2C_CLOCK_SOURCE);
}

/***********************************************************************************************************************
 * Initialization functions
 **********************************************************************************************************************/
void BOARD_InitPeripherals(void)
{
}

void BOARD_InitBUTTONsPeripheral(void)
{
  /* Initialize components */
  BOARD_SW_init();
}

void BOARD_InitLEDsPeripheral(void)
{
  /* Initialize components */
  BOARD_LEDS_init();
}

void BOARD_InitPMod_BRIDGEPeripheral(void)
{
  /* Initialize components */
  BOARD_BRIDGE_GPIO_init();
  BOARD_PMOD_SPI_init();
  BOARD_PMOD_I2C_init();
}

void BOARD_InitACCELPeripheral(void)
{
  /* Initialize components */
  BOARD_ACCEL_init();
  BOARD_ACCL_INTR_init();
}

void BOARD_InitQSPI_FLASHPeripheral(void)
{
  /* Initialize components */
  BOARD_SPIFI_RSTn_init();
}

void BOARD_InitDEBUG_UARTPeripheral(void)
{
  /* Initialize components */
  BOARD_DEBUG_UART_init();
}

void BOARD_InitENETPeripheral(void)
{
  /* Initialize components */
  BOARD_ENET_PHY_RSTn_init();
}

void BOARD_InitI2SPeripheral(void)
{
  /* Initialize components */
  BOARD_I2S_I2C_init();
}

/***********************************************************************************************************************
 * BOARD_InitBootPeripherals function
 **********************************************************************************************************************/
void BOARD_InitBootPeripherals(void)
{
}
